version: '2'
services:

  # nginx
  #------------------------------------

  # proxies connections to app/chat

  web:
    container_name: foodsharing_ci_web
    build:
      context: ..
      dockerfile: docker/Dockerfile.web.ci
    ports:
      - 38080:8080
    expose:
      - 8080
    depends_on:
      - app
      - chat

  # main php app
  #------------------------------------

  app:
    container_name: foodsharing_ci_app
    image: foodsharing_ci_app
    build:
      context: ..
      dockerfile: docker/Dockerfile.php.ci
    expose:
      - 9000
    depends_on:
      - db
      - redis
      - mailqueuerunner
    links:
      - redis:redis
      - db:db
      - chat:chat
      - influxdb
    environment:
      FS_ENV: test
    volumes:
      - selenium_downloads:/downloads
      - /dev/null:/usr/local/etc/php/conf.d/docker-php-ext-xdebug.ini

  # php mail queue runner
  #------------------------------------

  mailqueuerunner:
    container_name: foodsharing_ci_mailqueuerunner
    image: foodsharing_ci_app
    command: php run.php Mails queueWorker
    working_dir: /app
    restart: always
    depends_on:
      - db
      - redis
    links:
      - maildev
      - redis:redis
      - db:db
    environment:
      FS_ENV: test

  # php container for running codeception
  #------------------------------------

  codeception:
    container_name: foodsharing_ci_codeception
    image: foodsharing_ci_app
    depends_on:
      - db
      - redis
      - mailqueuerunner
    links:
      - redis:redis
      - db:db
      - chat:chat
      - influxdb
    environment:
      FS_ENV: test
    volumes:
      - selenium_downloads:/downloads
      - vendor_cache:/app/vendor
      - /dev/null:/usr/local/etc/php/conf.d/docker-php-ext-xdebug.ini

  chat:
    container_name: foodsharing_ci_chat
    command: sh -c "yarn && node server.js 0.0.0.0"
    build:
      context: ../chat
      dockerfile: docker/Dockerfile.chat.ci
    depends_on:
      - redis
    environment:
      REDIS_HOST: redis
    expose:
      - 1337
      - 1338
    volumes:
      - chat_node_modules_cache:/app/chat/node_modules

  # mysql
  #------------------------------------

  db:
    container_name: foodsharing_ci_db
    build:
      context: ..
      dockerfile: docker/Dockerfile.db.ci
    expose:
      - 3306
    ports:
      - 33306:3306
    environment:
      MYSQL_ROOT_PASSWORD: root
      TZ: Europe/Berlin
    tmpfs:
      - /tmp

  # redis
  #------------------------------------

  redis:
    container_name: foodsharing_ci_redis
    image: redis:5.0.8-alpine
    expose:
      - 6379

  # selenium
  #------------------------------------

  # for running browser-based tests

  selenium:
    container_name: foodsharing_ci_selenium
    image: registry.gitlab.com/foodsharing-dev/images/selenium:1.4
    shm_size: 512M
    links:
      - web:web
    expose:
      - 4444
    volumes:
      - selenium_downloads:/home/seluser/Downloads

  # maildev
  #------------------------------------

  maildev:
    command: >
      bin/maildev
        --web 80
        --smtp 25
        --hide-extensions STARTTLS
    image: djfarrelly/maildev
    container_name: foodsharing_ci_maildev

  influxdb:
    container_name: foodsharing_ci_influxdb
    build:
      context: ..
      dockerfile: docker/Dockerfile.influxdb.ci
    image: foodsharing_ci_influxdb
    command: >
      influxd -config /etc/influxdb/influxdb.toml
    environment:
      INFLUXDB_ADMIN_ENABLED: "true"
      INFLUXDB_DB: "foodsharing"

volumes:
  selenium_downloads:
  vendor_cache:
  client_node_modules_cache:
  chat_node_modules_cache:

